%bcond_with   		uclibc
%define Werror_cflags	%{nil} 
%define _ssp_cflags	%{nil}

Summary:	Multi-call binary combining many common Unix tools into one executable
Name:		busybox
Version:	1.21.1
Release:	%mkrel 3
Epoch:		1
License:	GPLv2
Group:		Shells
URL:		http://www.busybox.net/
Source0:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2
Source1:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2.sign
Source2:	busybox-1.15.2-config
Source3:	busybox-1.17.2-minimal-config
#Patch0:	busybox-1.12.1-static.patch
Patch1:		busybox-i.15.2-no-march_i386.patch
Patch12:	busybox-1.2.2-ls.patch
Patch16:	busybox-1.10.1-hwclock.patch
Patch17:	busybox-1.19.3-use-Os.diff

BuildRequires:	gcc >= 3.3.1-2mdk
%if %{with uclibc}
BuildRequires:	uClibc-static-devel >= 0.9.30.3-3
%define __cc	%{uclibc_cc}
%define	cflags	%{uclibc_cflags}
%else
BuildRequires:	glibc-static-devel
%define	cflags	%{optflags}
%endif
BuildRequires:	kernel-userspace-headers

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in GNU coreutils, shellutils, etc.
The utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included provide
the expected functionality and behave very much like their GNU counterparts.
BusyBox provides a fairly complete POSIX environment for any small or
embedded system.

BusyBox has been written with size-optimization and limited resources in
mind. It is also extremely modular so you can easily include or exclude
commands (or features) at compile time. This makes it easy to customize
your embedded systems. To create a working system, just add /dev, /etc,
and a kernel.

%package	static
Group:		Shells
Summary:	Static linked busybox

%description	static
This package contains a static linked busybox.

%prep
%setup -q
#%%patch0 -b .static -p1
%patch1 -b .no_march~ -p1
%patch12 -b .ls~ -p1
%patch16 -b .ia64~ -p1
%patch17 -b .Os~ -p1

%build
cat %{SOURCE2} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make oldconfig V=1
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.full.static
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.full


%if %{with uclibc}
cat %{SOURCE3} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make oldconfig V=1
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.minimal.static
%make CC=%{__cc} LDFLAGS="%{ldflags}" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.minimal
%endif

%check
# FIXME
%if 0
%make CC=%{__cc} V=1 check
%endif

%install
rm -rf %{buildroot}
install -m755 busybox.full -D %{buildroot}%{_bindir}/busybox
install -m755 busybox.full.static -D %{buildroot}/bin/busybox.static
%if %{with uclibc}
install -m755 busybox.minimal -D %{buildroot}%{uclibc_root}%{_bindir}/busybox.minimal
install -m755 busybox.minimal.static -D %{buildroot}%{uclibc_root}/bin/busybox.minimal.static
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS README TODO
%{_bindir}/busybox
%if %{with uclibc}
%{uclibc_root}%{_bindir}/busybox.minimal
%endif

%files static
%defattr(-,root,root)
%doc AUTHORS README TODO
/bin/busybox.static
%if %{with uclibc}
%{uclibc_root}/bin/busybox.minimal.static
%endif




%changelog
* Tue Nov 12 2013 tv <tv> 1:1.21.1-3.mga4
+ Revision: 550841
- patch 17: uses -Os
- disable uClibc build (trades 41k of overhead in busybox for saving 444k of
  dynamic uclibc in stage2: we don't want _both_ glibc & uclibc!)

* Sat Oct 19 2013 umeabot <umeabot> 1:1.21.1-2.mga4
+ Revision: 528921
- Mageia 4 Mass Rebuild

* Sat Jun 29 2013 fwang <fwang> 1:1.21.1-1.mga4
+ Revision: 448336
- new version 1.21.1

* Fri Jan 11 2013 umeabot <umeabot> 1:1.20.2-2.mga3
+ Revision: 347231
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jul 17 2012 rtp <rtp> 1:1.20.2-1.mga3
+ Revision: 271832
- bump dep on uClibc to get suitable headers

  + luigiwalser <luigiwalser>
    - 1.20.2
    - try different patches to not use missing header
    - add BuildRequires kernel-userspace-headers and upstream patch to fix build
    - re-diff patch from upstream to fix CVE-2011-2716

* Fri Jan 06 2012 shlomif <shlomif> 1:1.19.3-1.mga2
+ Revision: 192380
- New busybox version - 1.19.3

* Wed Apr 13 2011 tv <tv> 1:1.18.4-1.mga1
+ Revision: 84497
- drop patches 100-103 (merged upstream)
- new release

* Thu Jan 27 2011 erwan <erwan> 1:1.18.2-2.mga1
+ Revision: 42223
- Fixing typo
- Rebuild
- Adding latest patches

* Thu Jan 27 2011 erwan <erwan> 1:1.18.2-1.mga1
+ Revision: 42215
- imported package busybox

